// Header File
// Created 2/10/2005; 6:14:29 PM
#ifndef _LOAD_L
#define _LOAD_L
//this looks for all files of type "FD3D" and asks the user to chose one then returns a ptr to it or
//NULL if none chosen(ESC pressed) if no levels are on the calc then the internal level is returned
extern inline HANDLE loadLevel(void){
	HANDLE handles[MAX_LEVELES];
	const char *names[MAX_LEVELES];
	SYM_ENTRY *symPtr;
	short num=1;
	names[0]="New";
	register HANDLE *nextH=handles;
	register const char **nextName=names+1;
	BlackScreen();
	#ifdef VAT_FILES
		for(symPtr=SymFindFirst(NULL,FO_RECURSE);symPtr && num<=MAX_LEVELES;symPtr=SymFindNext()){
			if(symPtr->flags.flags_n&(SF_LOCKED|SF_FOLDER|SF_HIDDEN) || memcmp(HToESI(symPtr->handle)-5,(char[]){'F','D','3','D',0,OTH_TAG},6))continue;
			*(nextH++)=symPtr->handle;
			*(nextName++)=symPtr->name;
			num++;
		}
		if(num==1)goto return_new;
	#else
		if(!(symPtr=FFindFirst(FO_RECURSE,"FD3D",NULL)))goto return_new;
		do{
			*(nextH++)=symPtr->handle;
			*(nextName++)=symPtr->name;
			num++;
		}while((symPtr=FFindNext()) && num<=MAX_LEVELES);
	#endif
	register short key;
	if(!(key=menu(SYM_LEN*3,num,1,LEV_START,names)))return H_NULL;
	if(key==1){
		return_new:
		BlackScreen();
		EVENT ev;
		TEXT_EDIT te;
		char name[NAME_SIZE];
		name[0]=0;
		 //we only need to set alpha lock on calculators that have it
		#if !defined(NO_CHANGE_ALPHA_STATUS) && defined(USE_TI89)
			#ifdef NO_RESTORE_ALPHA_STATUS
				if(!AMS_1xx)//call SetAlphaStatus in a AMS indipendant way(Won't try if AMS<1.00)
					_rom_call(void,(char),163)(TRUE);//SetAlphaStatus
			#else
				unsigned char aST;
				if(!AMS_1xx)//call alphaLockOn in a AMS indipendant way(Won't try if AMS<1.00)
					_rom_call(void,(unsigned char*),481)(&aST);//alphaLockOn
			#endif
		#endif
		TE_openFixed (&te,DeskTop,&(WIN_RECT){(LCD_WIDTH/2)-3*(NAME_SIZE-1),37,(LCD_WIDTH/2)+3*(NAME_SIZE-1),46},name,NAME_SIZE-1,0);
		TE_select(&te,0,NAME_SIZE-1);
		TE_focus(&te);
		register short key;
		for(;;){
				key=EV_getc (ACTIVITY_IDLE, &ev);
				if(key==KEY_OFF2){
					off();
					continue;
				}
				if(key== KEY_ESC){
					#if !defined(NO_CHANGE_ALPHA_STATUS) && !defined(NO_RESTORE_ALPHA_STATUS) && defined(USE_TI89)
						*name=0;
						break;
					#else
						return H_NULL;
					#endif
				}
				if(key==KEY_ENTER)break;
				if((key>='A' && key<='Z') || (key>='a' && key<='z') || (key>='0' && key<='9') || key=='\\' || key>0xFF || key==0){
					TE_handleEvent(&te,&ev);
				}
		}
		#if !defined(NO_CHANGE_ALPHA_STATUS) && !defined(NO_RESTORE_ALPHA_STATUS) && defined(USE_TI89)
			if(!AMS_1xx)//call restoreAlphaLock in a AMS indipendant way(Won't try if AMS<1.00)
				_rom_call(void,(unsigned char*),483)(&aST);//restoreAlphaLock
		#endif
		if(!TokenizeSymName(name,0))return H_NULL;
		HANDLE temph=HeapAlloc(sizeof(WALL)+10);
		SYM_ENTRY *new;
		if(!(new=DerefSym(SymAdd(top_estack))))return H_NULL;
		new->handle=temph;
		void *fptr;
		*(unsigned short*)(fptr=HeapDeref(temph))=sizeof(WALL)+8;
		//initialize level whith inital data and type string
		memcpy(fptr+2,((char[10]){0xFF,0xFF,0,'\0','F','D','3','D','\0','\xF8'}),10);
		return temph;
	}
	key-=2;
	return handles[key];
}
#endif