// C Source File
// Created 12/16/2004; 3:28:40 PM


#include <tigcclib.h>


#define randomizeWall(_dest,_dif) ({short dummy;\
						asm(\
						"	subq.w #1,%[dif]\n"\
						"	moveq.l #-1,%[dest]\n"\
						"makeHole:\n"\
						"	jbsr rand\n"\
						"	and.w #15,%%d0\n"\
						"	moveq.l #-2,%%d1\n"\
						"	rol.w %%d0,%%d1\n"\
						"	and.w %%d1,%[dest]\n"\
						"	dbf      %[dif],makeHole\n"\
						:[dest]"=d" (_dest),[dif]"=d" (dummy):"1" (_dif):"a0","a1","d0","d1","d2","cc");})

	typedef union{
		struct {
			unsigned short W0:1, W1:1, W2:1, W3:1, W4:1, W5:1, W6:1, W7:1, W8:1, W9:1, W10:1, W11:1, W12:1, W13:1, W14:1, W15:1;
		}Wbits;
		struct {
			unsigned char Hi,Low;
		}Wchar;
	} WALL;


// Main Function
void _main(void)
{
	ESI argptr=top_estack;
	FILES dest;
	if(*argptr!=STR_TAG)ER_throw(ER_ARG_MUST_BE_STRING);
	argptr-=2;
	for(;*argptr;argptr--);
	register short err;
	if((err=FOpen(argptr+1,&dest,FM_WRITE,"FD3D"))==FS_BAD_NAME)ER_throw(ER_INVALID_PATHNAME);
	if(err==FS_ERROR)ER_throw(ER_LOCKED);
	argptr--;
	if(*argptr!=POSINT_TAG)ER_throw(ER_ARGUMENT);
	int i=GetIntArg(argptr);
	if(*argptr!=POSINT_TAG)ER_throw(ER_ARGUMENT);
	int diff=GetIntArg(argptr);
	randomize();
	for(;i;i--){
		register WALL wall;
		randomizeWall(wall,diff);
		FPutC(wall.Wchar.Low,&dest);
		FPutC(wall.Wchar.Hi,&dest);
	}
	FPutC(0,&dest);
	FClose(&dest);
}
