// C Source File
// Created 7/11/2004; 3:04:19 PM

#include "defs.h"

//char _rowread(register short mask asm("%d0"));

#if !defined(NO_LEVELS) && !defined(NO_EXT_LEV)
short __attribute__((__regparm__(5))) menu(short halfWidth,short max,short num,short y,MenuNames strs)
{
	SCR_RECT tmp;
	short num2draw=max>MENU_ITEMS?MENU_ITEMS:max;
	short stIdx=0;
	tmp.xy.y0=y+(num-1)*10-2;
	tmp.xy.y1=tmp.xy.y0+10;
	tmp.xy.x0=LCD_WIDTH/2-(halfWidth);
	tmp.xy.x1=tmp.xy.x0+2*halfWidth;
	register SCR_RECT *tptr=&tmp;
	FontSetSys(F_6x8);
	for(;;)
	{
		const char **toDraw=strs+stIdx;
		BlackScreen();
		#ifdef USE_VTI
			DrawStr(LCD_WIDTH/2-60,y-15,"WARNING: VTI vertion!",A_REVERSE);
		#endif
		//draws the strings centered left to right
		DrawStrs(y,toDraw,num2draw);
		if(stIdx>0)DrawChar(LCD_WIDTH/2-3,y-7,19,A_REVERSE);
		if(stIdx+MENU_ITEMS<max)DrawChar(LCD_WIDTH/2-3,y+MENU_ITEMS*10,20,A_REVERSE);
		waitNoKey();
		//I use the AMS routines here because it saves space and speed is not critical here
		ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
		for(;;){
			BEGIN_KEYTEST
				if(_keytest_optimized_mask(RR_UP_DN)){
					ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
					if(_keytest_optimized(RR_DOWN))
					{
						if(num2draw>num-stIdx){
							tptr->xy.y0+=10;
							num++;
						}else{
							if(stIdx+MENU_ITEMS<max){
								stIdx++;
								num++;
								break;
							}
							num=stIdx+1;
							tptr->xy.y0=y-2;
						}
					}else{
						if(num>1+stIdx){
							tptr->xy.y0-=10;
							num--;
						}else{
							if(stIdx>0){
								stIdx--;
								num--;
								break;
							}
							num=num2draw;
							tptr->xy.y0+=10*(num2draw-1);
						}
					}
					tptr->xy.y1=tptr->xy.y0+10;
					ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
					waitNoKey();
				}
				if(_keytest_optimized(RR_2ND) || test_Hand() || test_enter()){
					return num;
				}
			END_KEYTEST
			if(_keytest(RR_ESC)){
				return 0;
			}
			//idle is actually smaller than using low power port directly
			idle();
		}
	}
}
#else
//use a non scrolable menu because a scroleable one is not needed
short __attribute__((__regparm__(5))) menu(short halfWidth,short max,short num,short y, const char **strs)
{
	SCR_RECT tmp;
	tmp.xy.y0=y+(num-1)*10-2;
	tmp.xy.y1=tmp.xy.y0+10;
	tmp.xy.x0=LCD_WIDTH/2-(halfWidth);
	tmp.xy.x1=tmp.xy.x0+2*halfWidth;
	BlackScreen();
	FontSetSys(F_6x8);
	#ifdef USE_VTI
		DrawStr(LCD_WIDTH/2-60,y-17,"WARNING: VTI vertion!",A_REVERSE);
	#endif
	//draws the strings centered left to right
	DrawStrs(y,strs,max);
	waitNoKey();
	register SCR_RECT *tptr=&tmp;
	//I use the AMS routines here because it saves space and speed is not critical here
	ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
	for(;;){
		BEGIN_ROWSCAN(0)
			if(rowmask(UP_DN_MASK)){
				ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
				if(rowscan(RR_DOWN))
				{
					if(num<max){
						tptr->xy.y0+=10;
						num++;
					}else{
						num=1;
						tptr->xy.y0=y-2;
					}
				}else{
					if(num>1){
						tptr->xy.y0-=10;
						num--;
					}else{
						num=max;
						tptr->xy.y0+=10*(max-1);
					}
				}
				tptr->xy.y1=tptr->xy.y0+10;
				ScrRectFill(tptr,&(SCR_RECT){{0,0,239,127}},A_XOR);
				waitNoKey();
			}
			if(rowscan(RR_2ND) || test_Hand() || test_enter())return num;
		END_ROWSCAN
		if(_keytest(RR_ESC))return 0;
		//idle is actually smaller than using low power port directly
		idle();
	}
}
#endif